/*
 * main.cc -- Contains main(), duh.
 *
 * $Id: main.cc,v 1.5 2000/01/16 04:19:31 devphil Exp $
*/


#include "go_decls.h"
#include "outfile.h"
#include "filegenfuncs.h"
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <iostream>
#include <stdexcept>


int main (int argc, char *argv[])
{
    try {
        // Well, duh, this was a given...
        int nextarg = genopt_process_options (argc, argv);

        // g_p_o guarantees that (argc - nextarg) will be at
        // least (in the case of genopt) 1, but we should check for more, too
        if (argc - nextarg != 1) {
            std::cerr << "Aw, just give me one file for right now, 'kay?\n";
            ::exit(1);
        }
    
{ char *p = static_cast<char*>(malloc(1024*512)); p[0] = 'b'; free(p); }
    
        // Run the parse.
        extern FILE* yyin;
        extern int yyparse();
        yyin = fopen (argv[nextarg], "r");
        if (yyin == NULL) {
            std::cerr << "genopt: Input file " << argv[nextarg]
                      << " couldn't be opened!\n";
            perror("genopt");
            ::exit(1);
        }
        if (yyparse()) {
            std::cerr << "genopt:  Parse failed." << std::endl;
            ::exit(1);
        }
        fclose (yyin);
    
        // Write the two files.
        write_header_file();
        write_source_file();
    }
    catch (std::exception& E) {
        std::cerr << "Wow, something REALLY screwed up!  Exception:  "
                  << E.what() << endl;
        ::exit(1);
    }

    return 0;
}


