/*
 * utils.h -- A bunch of string-generating functions and the like.
 *
 * $Id: utils.h,v 1.4 2000/01/18 22:34:35 devphil Exp $
*/

#ifndef GO_UTILS_H
#define GO_UTILS_H

#include <iosfwd>
#include <string>


//  os << spaces(N)   prints N spaces
struct spaces_ { int n; };
inline spaces_ spaces (int N)
{
  spaces_ x;
  x.n = N;
  return x;
}
inline ostream& operator<< (ostream& os, spaces_ s)
{
  while (s.n-- > 0)  os.put(' ');
  return os;
}


//  preprocsymbol("go_outfile.h") returns "GO_OUTFILE_H"
extern string    preprocsymbol (const string&);


//  rjust(str,text) appends enough spaces to 'str' such that 'text' starts
//  on (1-based) index 32, and then appends 'text' (if it wraps it will
//  also be indented to 32.  Explicit newlines and quotes are added (this
//  work is shared with Option::quoted_help_string).
extern void      rjust (string&, const string&);


//  linebreak(str,indent,initialindent) replaces spaces with newlines to
//  break up 'str'.  After each newline 'indent' spaces will be inserted.
//  'initialindent' characters are assumed to be in 'str' already, and
//  those will not be broken up.
extern void      linebreak (string&, string::size_type, string::size_type);


#endif /* GO_UTILS_H */

